# -------------------------------------------------------------------------------
#   ----  www. r i d o l f a . e u ---
#
#
#### *Copyright 2018  Ridolfa.eu / Rolf S.*
#### *
#### * Licensed under the EUPL, Version 1.1 or – as soon they    *
####   will be approved by the European Commission - subsequent
####   versions of the EUPL (the "Licence");
#### * You may not use this work except in compliance with theLicence.
#### * You may obtain a copy of the Licence at:
####   https://joinup.ec.europa.eu/software/page/eupl
#
#   Rolf Schwerhoff:        RSf_220609
#   Project:                50 Solar
# ------------------------------------------------------------------------------

from tools import SolarTools
import config as cfg
from solarplant import SolarPlantRegisters

print("\n===============================================================")
print("---  SolarEdge ModBus_TCP Examples")
print("\nWIP, The examples show different ways how to get the solar\n\
plant data and descriptions")
print("===============================================================")


def init_logger():
    logger = SolarTools().init_logger(
        logconsole=True,
        logfile=cfg.Logger['LogFile'],
        loglevel=cfg.Logger['LogLevel'],
        filesize=cfg.Logger['FileSize'],
        filebackups=cfg.Logger['FileBackups']
    )
    return logger


def results(data):
    # data = [name, description, unit, value]
    print("{} {} {} {}".format(data[0], data[1], data[2], data[3]))

def info():
    pass
    print("\n--- Info ----------------------\n")
    print(mregs.i_status())
    print(mregs.meter_info())
    print(mregs.inverter_master_info())
    print(mregs.battery_info())

    results(mregs.inv_block1_scale16())
    results(mregs.inv_block1_scale16(reglist_key="40079X"))  # "I_AC_VoltageLxN"
    results(mregs.inv_block1_scale16(reglist_key="40073X"))  # "I_AC_VoltageLxN"

    mregs.archive()

def basics():
    pass
    print("\n--- Basics ----------------------\n")
    print("")
    # results(mregs.bat_related_energy())
    results(mregs.bat_inst_power())
    # results(mregs.bat_available_energy())

    # results(mregs.bat_state_of_health())
    results(mregs.bat_state_of_energy())
    print("")

    dc = mregs.inv_block1_scale16(reglist_key="40100")  # Inv DC-Power
    ac = mregs.inv_block1_scale16(reglist_key="40083")  # Inv AC-Power
    print("Inv DC-Power (W)\t", dc)  # mregs.i_dc_power())
    print("Inv AC-Power (W)\t", ac)
    print("DC-AC loss (%)\t", 100 * mregs.i_dc_ac_conversion_loss(dc[3][0], ac[3][0]))
    print("\n")
    results(mregs.met_block1_scale16(reglist_key="40206"))  # "M_AC_POWER"

    print("Exported Energy (kWh)\t", mregs.m_energy(reglist_key="40226")[3][0])  # Exported Real Energy
    print("Imported Energy (kWh)\t", mregs.m_energy(reglist_key="40234")[3][0])  # Imported Real Energy


def good_to_know():
    print("\n--- Gut zu wissen... ----------------------\n")
    results(mregs.i_dc_voltage())
    results(mregs.i_dc_current())
    print("Berechnete Gleichspannungsleistung (Wh\t", round(mregs.i_dc_voltage()[3][0] * mregs.i_dc_current()[3][0], 2))
    results(mregs.inv_block1_scale16(reglist_key="40100"))  # "I_DC_Power"
    print("\n")
    regdata = mregs.m_ac_freq()
    print(regdata[1], regdata[3], regdata[2])

    macv = mregs.met_block1_scale16(reglist_key="40196X")
    macc = mregs.met_block1_scale16(reglist_key="40191X")
    results(macv)  # "M_AC_VoltageLxN"
    results(macc)  # "M_AC_CurrentLxN"

    macp = 0
    for i in range(3):
        macp +=  (macv[3][i] * macc[3][i])
    print("M_AC_Power", macp )


    print("Available Heater power:", mregs.met_block1_scale16(reglist_key="40206")[3][0], " (W)")
    # print("\n--- Register Group test ----------------------\n")
    # print(mregs.read_pv())

def se_monitor():
    print("\n--- Werte entsprechend dem SE Monitorportal--------------\n")







mregs = SolarPlantRegisters(logger=init_logger()) # read all register blocks
print(mregs.reg_update_time())
if not mregs.read_holding_regs() == cfg.ERR_ERROR:
    info()
    basics()
    good_to_know()
else:
    print("Sorry, a ModBusTCP error occured while reading the holding registers. Program terminated")



