# -------------------------------------------------------------------------------
#   ----  www. r i d o l f a . e u ---
#
#
#### *Copyright 2018  Ridolfa.eu / Rolf S.*
#### *
#### * Licensed under the EUPL, Version 1.1 or – as soon they    *
####   will be approved by the European Commission - subsequent
####   versions of the EUPL (the "Licence");
#### * You may not use this work except in compliance with theLicence.
#### * You may obtain a copy of the Licence at:
####   https://joinup.ec.europa.eu/software/page/eupl
#
#   Rolf Schwerhoff:        RSf_220609
#   Project:                50 Solar
# ------------------------------------------------------------------------------
# Hot Water Boiler Configuration File 


#-------------------------------------------------------------------------------
#   Miscellaneous
#-------------------------------------------------------------------------------

ERR_ERROR = -99  # General  error tag

#-------------------------------------------------------------------------------
#   SPI, LoRa
#-------------------------------------------------------------------------------

# SPI Bus TTGO
LoRaSpi = {
    #"Bus": 0,     # Softwarebus
    "PinCS0": 18,
    "PinSCK": 5,
    "PinMOSI": 27,
    "PinMISO": 19,
    "Baudrate": 200000,  # Hz
    "Polarity": 0,
    "Phase": 0,
    }

# # Future task: Replace with LoRa Implicit Header etc.
LoRaNode = {
    "F40CentralUnit": "A",
    "Boiler": "B",
    "Sniffer": "C"
    }

# Pin wiring LoRa device to Controller
LoraPins = {
    "Reset": 23,
    "NSS": LoRaSpi["PinCS0"],  # chip select
    "DIO0": 26  # receive irq
    }

# LoRa Radio Parameter
# Set radio parameters ( e.g  Transmit frequency, Signal bandwidth, Spreading factor, Coding rate)
# See register settings in the SX1276 data sheet

LoRaRadio = {
    "Freq": (868, 217, 0, 0),       # (868 MHz, RegFrMsb(0x06, RegFrMid(0x07), RegFrLsb(0x08)
    "RegConfig1": 0x72, # RegModemConfig1(0x1D
    "RegConfig2": 0x74, # RegModemConfig2(0x1E
    "RegConfig3": 0x04, # RegModemConfig3(0x26
    "TxPowerLevel": 5, # REG_PA_CONFIG
    "PreambleLength": 8, # REG_PREAMBLE_LSB , REG_PREAMBLE_LSB,
    "PowerPin": 1, # boost pin is 1, non-boost pin is 0
    "SyncWord": 0x12, # REG_SYNC_WORD
    }


#-------------------------------------------------------------------------------
#   I2C, OLED SSD1306
#-------------------------------------------------------------------------------
I2c  = {
    "Bus": 1,     # Hardwarebus 1
    "Frequency": 400000,    # Hz
    "PinSDA": 21,     # Pin
    "PinSCL": 22,    # Pin
}

OLed = {
    "I2cAddr": 0x3c,
    "PixWidth": 128,
    "PixHeight": 32,
    "PixCharHeight": 8,
    "PixCharWidth": 8,
    "RowCharMax": 16,
    "ColCharMax": 4,
    "CharMax": 64
}
Oled_StartScreen = {
    "TextA": 'SOLAR - BOILER',
    "TextB": 'Okt. 2022 / RolfS',
    "TextC": '--- Ridolfa.eu ---  2022',
    "Logo": 'logo_tierzucht.pm',
    # "Logo": 'logo_ridolfa.pm',
}

#-------------------------------------------------------------------------------
#   Heater Control
#-------------------------------------------------------------------------------

SEND_ALIVE_SIGNAL = 60  # sec, periodic timer, checking the host data connection
